//DS18S20 Lib


//Includes
#include <avr/io.h>
#include <util/delay.h>

//Datenleitung
#define DQ_Port PORTD
#define DQ_Pin  PIND
#define DQ_Bit  7
#define DQ_DDR  DDRD

//Bit Manipulationen
#define set_bit(var, bit)	 ((var) |= (1 << (bit)))
#define clear_bit(var, bit) ((var) &= ~(1 << (bit)))
#define read_bit(var, bit)  ((var) & (1 << (bit)))

//OneWire Reset
unsigned char ow_reset(void) {
	
	unsigned char zw;

	clear_bit(DQ_Port, DQ_Bit);	//DQ auf Low
	_delay_us(496);					//496 s warten
	set_bit(DQ_Port, DQ_Bit);		//DQ auf High
	_delay_us(65);						//65 s warten
	zw = read_bit(DQ_Pin, DQ_Bit);//Zustand von DQ in zw einlesen
	_delay_us(424);					//424 s warten (Ende des Resetvorgangs)
	
	return zw;							//zw zurckgeben
											//0 = Slave vorhanden
											//1 = kein Slave vorhanden	
}
